<?php 
/*
Plugin Name: SNS Image Gallery
Plugin URI: http://securenext.com/
Description: Enables you to add images for slider to appropriate pages/posts... This plugin used to manage two version of images like before and after. 
Author: Malarvizhi K
Version: 2.0
Author URI: http://malarvizhik.wordpress.com/
*/

#---------------------------------------------------
# Load other plugin files and configuration
#---------------------------------------------------

class SliderImages {
	var $slider_images_table;
	var $paged = false;
	
	function __construct() {
		global $wpdb;
		$wpdb->prefix;
		$this->slider_images_table = $wpdb->prefix.'slider_images';
		add_action('init', array(&$this, 'init'));
		add_action('activate_slider_images/slider_images.php', array(&$this, 'install'));
		$this->paged = array();
	}

	function init() {
		$this->install();
		load_plugin_textdomain('slider_images', PLUGINDIR.'/slider_images');
		add_action('admin_menu', array(&$this, 'slider_images_dashboard'));
		$this->init_uploads();
    	$this->handle_slider_images();
    }

	function init_uploads() {
		if (! defined('UPLOADS_TMP_DIR'))
		define('UPLOADS_TMP_DIR', WP_CONTENT_DIR . '/uploads');
		if (! defined('HOME_UPLOADS_TMP_DIR'))
		define('HOME_UPLOADS_TMP_DIR', WP_CONTENT_DIR . '/uploads/sliderimages');
		if (! defined('HOME_UPLOADS_TMP_THUMB_DIR'))
		define('HOME_UPLOADS_TMP_THUMB_DIR', WP_CONTENT_DIR . '/uploads/sliderimages/thumb');
		define ("MAX_SIZE","1064"); 
		$home= get_option('home');
		define('HOME_UPLOADS_TMP_FOLDER', $home.'/wp-content/uploads/sliderimages');
		define('HOME_UPLOADS_TMP_THUMB_DIR', $home.'/wp-content/uploads/sliderimages/thumb');
	    wp_mkdir_p(trailingslashit(UPLOADS_TMP_DIR));
        @chmod(UPLOADS_TMP_DIR, 0777);
		
        wp_mkdir_p(trailingslashit(HOME_UPLOADS_TMP_DIR));
        @chmod(HOME_UPLOADS_TMP_DIR, 0777);
        wp_mkdir_p(trailingslashit(HOME_UPLOADS_TMP_THUMB_DIR));
        @chmod(HOME_UPLOADS_TMP_THUMB_DIR, 0777);

    }	

	function install() {
        global $wpdb;
		$mysql1 		= false;
		$upgrade 		= false;
		if ( $wpdb->has_cap( 'collation' ) ) {
			if ( ! empty($wpdb->charset) )
				$charset_collate = "DEFAULT CHARACTER SET $wpdb->charset";
			if ( ! empty($wpdb->collate) )
				$charset_collate .= " COLLATE $wpdb->collate";
		}
		if(!$this->slider_images_mysql_table_exists($this->slider_images_table)) {
		$add1 = "CREATE TABLE `".$this->slider_images_table."` (
	  		`id` mediumint(8) unsigned NOT NULL auto_increment PRIMARY KEY,
	  		`pid` int(50) NOT NULL,
			`pimage_title` varchar(255) NOT NULL ,
	  		`pimage_url` varchar(255) NOT NULL ,
			`pimage_urlnew` varchar(255) NOT NULL ,
			`pimage_link` varchar(255) NOT NULL,
	  		`pimage_desc` varchar(255) NOT NULL,
			`pimage_order` int(50) NOT NULL
			) ".$charset_collate;			
			if(mysql_query($add1) === true) {
				$myqsl1 = true;
			} else {
				$mysql1 = false;
			}
		}
	if($mysql1 == false) {
		//$this->slider_images_mysql_warning();
	}

	}

function slider_images_mysql_table_exists($table_name) {
	global $wpdb;

	foreach ($wpdb->get_col("SHOW TABLES",0) as $table ) {
		if ($table == $table_name) {
			return true;
		}
	}
	return false;
}
/*-------------------------------------------------------------
 Name:      slider_images_mysql_warning

 Purpose:   Database errors if things go wrong
 Receive:   -none-
 Return:	-none-
-------------------------------------------------------------*/
function slider_images_mysql_warning() {
	echo '<div class="updated"><h3>'.__('WARNING!', 'wpevents').' '.__('The MySQL table was not created! You cannot store events. See if you have the right MySQL access rights and check if you can create tables.', 'wpevents').' '.__('Contact your webhost/sysadmin if you must.', 'wpevents').' '.sprintf(__('If this brings no answers seek support at <a href="%s">%s</a>', 'wpevents'),'http://forum.at.meandmymac.net', 'http://forum.at.meandmymac.net').'. '.__('Please give as much information as you can related to your problem.', 'wpevents').'</h3></div>';
}

function slider_images_plugin_uninstall() {
	global $wpdb;

	// Deactivate Plugin
	$current = get_settings('active_plugins');
    array_splice($current, array_search( "slider-images/slider-images.php", $current), 1 );
	update_option('active_plugins', $current);
	do_action('deactivate_' . trim( $_GET['plugin'] ));

	// Drop MySQL Tables
	print $SQL = "DROP TABLE `".$this->slider_images_table."`";
	mysql_query($SQL) or die(__('An unexpected error occured')."<br />".mysql_error());
	
	// Delete Option
	delete_option('slider_images_config');
	$this->slider_images_return('uninstall');
}

function handle_slider_images() {
	global $wpdb;
 if( isset($_POST['slider_images-new_slider_image'] )  || isset($_POST['slider_images-edit_slider_image'])  ) {
 			$pid = $_POST['page_id'];
 			$description = stripslashes($_POST['description']);
			$link = $_POST['link'];
			$porder = $_POST['imgorder'];
			$pimage_title = $_POST['title'];
			$gid = $_POST['gallery'];
 }
 if( isset($_POST['slider_images-new_slider_image'] ) || (isset($_POST['slider_images-duplicate_slider_image']) && $_POST['id'])) {
 
 			check_admin_referer("new-slider_image");
			
            $this->add_slider_image( $pid, $pimage_title, $description, $link, $porder,$gid);

      	  if( $_POST['spl_id']=='') 
			 wp_redirect("admin.php?page=slider_images_management&slider_images_message=1&slider_image_name=".urlencode(htmlentities($restaruant, ENT_QUOTES)));
			else 
			 wp_redirect("admin.php?page=slider_images_management&slider_images_message=4&slider_image_name=".urlencode(htmlentities($restaruant, ENT_QUOTES)));

 }elseif( isset($_GET['slider_images-delete'])) {
            $id = $_GET['slider_images-delete'];
			$name = stripslashes($_GET['slider_images_name']);
            check_admin_referer("delete-slider_images_$id");
			
            $this->delete_slider_image($id);
			wp_redirect("admin.php?page=slider_images_management&slider_images_message=3&slider_image_name=".urlencode(htmlentities($name, ENT_QUOTES)));

}elseif( isset($_POST['slider_images-edit_slider_image'])) {
			 $id = $_POST['id'];
			check_admin_referer("edit-slider_image_$id");
            $this->edit_slider_image($id, $pid, $pimage_title, $description, $link, $porder,$gid);
		wp_redirect("admin.php?page=slider_images_management&slider_images_message=2&slider_image_name=".urlencode(htmlentities($restaruant, ENT_QUOTES)));

}



}





/*-------------------------------------------------------------
 Name:      edit_slider_image

 Purpose:   Edit Slider Images
 Receive:   slider Images data
 Return:    -slider Images id-
-------------------------------------------------------------*/

function edit_slider_image($spl_id,$pid, $pimage_title, $description, $link, $porder,$gid){
       global $wpdb;
       $spl_id = (int)$spl_id;
       $uploads_dir = HOME_UPLOADS_TMP_DIR;
	   
	   
	$getEditImage_query	=	"SELECT * FROM {$this->slider_images_table} where id = {$spl_id}";
	$getEditImage		=	$wpdb->get_results($getEditImage_query);
	$editimagename = $getEditImage[0]->pimage_url;
		if($_FILES["pagepostpicture"]["name"])	{
		if(file_exists($uploads_dir."/".$editimagename))	{
			@unlink($uploads_dir."/".$editimagename);
		}
		if(!empty($_FILES["pagepostpicture"]["error"]))	{
			switch($_FILES["pagepostpicture"]["error"])	{
				case '1':
					$error = 'The uploaded file exceeds the upload_max_filesize directive in php.ini';
					break;
				case '2':
					$error = 'The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form';
					break;
				case '3':
					$error = 'The uploaded file was only partially uploaded';
					break;
				case '4':
					$error = 'No file was uploaded.';
					break;
				case '6':
					$error = 'Missing a temporary folder';
					break;
				case '7':
					$error = 'Failed to write file to disk';
					break;
				case '8':
					$error = 'File upload stopped by extension';
					break;
				case '999':
				default:
					$error = 'No error code avaiable';
			}
		}
		elseif(empty($_FILES["pagepostpicture"]["tmp_name"]) || $_FILES['fileToUpload']['tmp_name'] == 'none')	{
			$error = 'No file was uploaded..';
		}
		else	{
			if(($_FILES["pagepostpicture"]["type"] == 'image/jpeg') || ($_FILES["pagepostpicture"]["type"] == 'image/pjpeg'))	{
				$photoext = ".jpg";
			}
			elseif($_FILES["pagepostpicture"]["type"] == 'image/gif')	{
				$photoext = ".gif";
			}
			elseif($_FILES["pagepostpicture"]["type"] == 'image/png')	{
				$photoext = ".png";
			}
			$filename = time().$photoext;
			$filepath = $uploads_dir."/".$filename;
			move_uploaded_file($_FILES["pagepostpicture"]["tmp_name"], $filepath);
			$slidimgname = $filename;
		}
	}
	if($slidimgname != "")	{		
		$query2 = "UPDATE {$this->slider_images_table} SET pid=%d, pimage_title=%s, pimage_url=%s,pimage_link=%s, pimage_desc=%s, pimage_order=%d , gid=%d WHERE id=%d";
        $query2 = $wpdb->prepare($query2, $pid, $pimage_title, $slidimgname, $link, $description, $porder, $gid, $spl_id);
        $wpdb->query($query2);
	}
	else	{
		$query2 = "UPDATE {$this->slider_images_table} SET pid=%d, pimage_title=%s, pimage_link=%s, pimage_desc=%s, pimage_order=%d, gid=%d WHERE id=%d";
        $query2 = $wpdb->prepare($query2, $pid, $pimage_title, $link, $description, $porder, $gid, $spl_id);
        $wpdb->query($query2);
	}
}

/*-------------------------------------------------------------
 Name:      delete_slider_image

 Purpose:   Delete 
 Receive:   slider_image data
 Return:    -slider image id-
-------------------------------------------------------------*/

function delete_slider_image($spl_id){
        global $wpdb;
		$side_data = $wpdb->get_row("SELECT * FROM {$this->slider_images_table} WHERE id=$spl_id ");
		//echo HOME_UPLOADS_TMP_DIR.'/'.$side_data->pimage_url."<br>";
		//echo HOME_UPLOADS_TMP_THUMB_DIR.'/'.$side_data->pimage_urlnew;
		//die();
        $query = "DELETE FROM {$this->slider_images_table} WHERE id=$spl_id ";
        $wpdb->query($query);
		@unlink(HOME_UPLOADS_TMP_DIR.'/'.$side_data->pimage_url);
		@unlink(HOME_UPLOADS_TMP_THUMB_DIR.'/'.$side_data->pimage_url);

		@unlink(HOME_UPLOADS_TMP_DIR.'/'.$side_data->pimage_urlnew);
		@unlink(HOME_UPLOADS_TMP_THUMB_DIR.'/'.$side_data->pimage_urlnew);

}


/*-------------------------------------------------------------
 Name:      add_slider_image

 Purpose:   Add Slider
 Receive:   Slider data
 Return:    -Slider id-
-------------------------------------------------------------*/
    function get_dpi($filename){  
      
        // open the file and read first 20 bytes.  
        $a = fopen($filename,'r');  
        $string = fread($a,20);  
        fclose($a);  
      
        // get the value of byte 14th up to 18th  
        $data = bin2hex(substr($string,14,4));  
        $x = substr($data,0,4);  
        $y = substr($data,4,4);  
        return array(hexdec($x),hexdec($y));  
      
    }  
      
function add_slider_image($pid, $pimage_title, $description, $link, $porder,$gid)	{
	global $wpdb;
	$img_count=0;
	//$uploads_dir = HOME_UPLOADS_TMP_DIR;
	$uploads_dir = WP_CONTENT_DIR . '/uploads/sliderimages';
	
	if($_FILES["pagepostpicture"]["name"])	{
		if(!empty($_FILES["pagepostpicture"]["error"]))	{
			switch($_FILES["pagepostpicture"]["error"])	{
				case '1':
					$error = 'The uploaded file exceeds the upload_max_filesize directive in php.ini';
					break;
				case '2':
					$error = 'The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form';
					break;
				case '3':
					$error = 'The uploaded file was only partially uploaded';
					break;
				case '4':
					$error = 'No file was uploaded.';
					break;
				case '6':
					$error = 'Missing a temporary folder';
					break;
				case '7':
					$error = 'Failed to write file to disk';
					break;
				case '8':
					$error = 'File upload stopped by extension';
					break;
				case '999':
				default:
					$error = 'No error code avaiable';
			}
		}
		elseif(empty($_FILES["pagepostpicture"]["tmp_name"]) || $_FILES['fileToUpload']['tmp_name'] == 'none')	{
			$error = 'No file was uploaded..';
		}
		else	{
			if(($_FILES["pagepostpicture"]["type"] == 'image/jpeg') || ($_FILES["pagepostpicture"]["type"] == 'image/pjpeg'))	{
				$photoext = ".jpg";
			}
			elseif($_FILES["pagepostpicture"]["type"] == 'image/gif')	{
				$photoext = ".gif";
			}
			elseif($_FILES["pagepostpicture"]["type"] == 'image/png')	{
				$photoext = ".png";
			}
			$filename = time().$photoext;
			$filepath = $uploads_dir."/".$filename;
			move_uploaded_file($_FILES["pagepostpicture"]["tmp_name"], $filepath);
			$before_slidimgname = $filename;

				if (file_exists($filepath)) {
				$_POST["crop"]=1;
				require_once('thumb/phpthumb.class.php');
				
				$phpThumb = new phpThumb();
				$phpThumb->src = $filepath;
				$size = filesize($filepath);
				$phpThumb->q = 85;
				$phpThumb->w ='228'; //$thumbx;
				$phpThumb->h ='162'; //$thumby;	
				if ($_POST["crop"]==1) $phpThumb->zc = 1;
				$phpThumb->config_output_format = 'jpeg';
				if ($phpThumb->GenerateThumbnail()) $phpThumb->RenderToFile(WP_CONTENT_DIR."/uploads/sliderimages/thumb/".$before_slidimgname);
			}
		}
	}
	
		list($width, $height, $type, $attr) = getimagesize($filepath);
		if($width!=560 && $height!=420){
			unlink($filepath);
			$img_count++;
		}

		if($_FILES["apagepostpicture"]["name"])	{
		if(!empty($_FILES["apagepostpicture"]["error"]))	{
			switch($_FILES["apagepostpicture"]["error"])	{
				case '1':
					$error = 'The uploaded file exceeds the upload_max_filesize directive in php.ini';
					break;
				case '2':
					$error = 'The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form';
					break;
				case '3':
					$error = 'The uploaded file was only partially uploaded';
					break;
				case '4':
					$error = 'No file was uploaded.';
					break;
				case '6':
					$error = 'Missing a temporary folder';
					break;
				case '7':
					$error = 'Failed to write file to disk';
					break;
				case '8':
					$error = 'File upload stopped by extension';
					break;
				case '999':
				default:
					$error = 'No error code avaiable';
			}
		}
		elseif(empty($_FILES["apagepostpicture"]["tmp_name"]) || $_FILES['fileToUpload']['tmp_name'] == 'none')	{
			$error = 'No file was uploaded..';
		}
		else	{
			if(($_FILES["apagepostpicture"]["type"] == 'image/jpeg') || ($_FILES["apagepostpicture"]["type"] == 'image/pjpeg'))	{
				$aphotoext = ".jpg";
			}
			elseif($_FILES["apagepostpicture"]["type"] == 'image/gif')	{
				$aphotoext = ".gif";
			}
			elseif($_FILES["apagepostpicture"]["type"] == 'image/png')	{
				$aphotoext = ".png";
			}
			$filename = 5+time().$aphotoext;
			$filepath = $uploads_dir."/".$filename;
			move_uploaded_file($_FILES["apagepostpicture"]["tmp_name"], $filepath);
			$after_slidimgname = $filename;
			
			
				if (file_exists($filepath)) {
				$_POST["crop"]=1;
				require_once('thumb/phpthumb.class.php');
				$phpThumb = new phpThumb();
				$phpThumb->src = $filepath;
				$size = filesize($filepath);
				$phpThumb->q = 85;
				$phpThumb->w ='228'; //$thumbx;
				$phpThumb->h ='162'; //$thumby;	
				if ($_POST["crop"]==1) $phpThumb->zc = 1;
				$phpThumb->config_output_format = 'jpeg';
				if ($phpThumb->GenerateThumbnail()) $phpThumb->RenderToFile(WP_CONTENT_DIR."/uploads/sliderimages/thumb/".$after_slidimgname);
			}
		}
	}	

	list($width, $height, $type, $attr) = getimagesize($filepath);
	if($width!=560 && $height!=420){
		unlink($filepath);
		$img_count++;
	}
	if($img_count<>0){
		echo "<script>window.location.href='admin.php?page=slider_images_management&imgerr=1'</script>";
	}else{
	$query = "INSERT IGNORE INTO {$this->slider_images_table} (pid,pimage_title,pimage_url,pimage_urlnew,pimage_link,pimage_desc,pimage_order,gid) VALUES (%d,%s,%s,%s,%s,%s,%d,%d)";

	$query = $wpdb->prepare($query, $pid, $pimage_title, $before_slidimgname,$after_slidimgname,$link, $description, $porder,$gid);
	$wpdb->query($query);
	$spl_id=$wpdb->insert_id;
	}
}



/*-------------------------------------------------------------
 Name:      slider_images_dashboard

 Purpose:   Add pages to admin menus
 Receive:   -none-
 Return:    -none-
-------------------------------------------------------------*/
function slider_images_dashboard()	{
	global $slider_images_config;
	$page =	add_object_page('Slider Images', 'Slider Images', 'manage_options', 'slider_images_management',  array(&$this, 'slider_images_page'));
}

/*-------------------------------------------------------------
 Name:      slider_images_page

 Purpose:   Return to Slider management
 Receive:   $action, $arg
 Return:    -none-
-------------------------------------------------------------*/
function slider_images_page()	{
	global $wpdb;

		$getPagePostid = "SELECT * FROM ".$wpdb->prefix."posts WHERE post_status= 'publish'";
		$getPagePostids = $wpdb->get_results($getPagePostid,ARRAY_A);

		$page_id_query	=	"SELECT * FROM ".$wpdb->prefix."posts where post_status = 'publish'";
		$page_id_res	=	$wpdb->get_results($page_id_query);
		$page_id_ary = $this->object_to_array($page_id_res);
		for($pid=0;$pid<count($page_id_ary);$pid++)	{
			$pgid[$pid] = $page_id_ary[$pid]["ID"];
		}
		$slider_images_query	=	"SELECT * FROM {$this->slider_images_table} s left join wp_image_gallery g on s.gid=g.gid";
		$slider_images			=	$wpdb->get_results($slider_images_query);

		if(empty($slider_images))	{
			echo '<div class="error" id="err_msg"><p>';
				_e('There is no images for any posts/pages.', 'slider_images');
			echo '</p></div>';
		}
		else{
			echo '<div class="error" id="err_msg" style="display:none;"></div>';
		}
		if(isset($_GET['slider_images_message']))	{
			$messages = array(	'1' => __("Successfully added the new slider image <b>%s</b>", 'slider_images'),
								'2' => __("Successfully edited the slider image <b>%s</b>", 'slider_images'),
								'3' => __("Successfully deleted the slider image <b>%s</b>", 'slider_images'));
			$slider_image = @stripslashes($_GET['slider_image']);
			$msg = sprintf($messages[$_GET['slider_images_message']], $slider_image);
			echo "<div id=\"message\" class=\"updated fade\"><p>$msg</p></div>";
		}
		?>
		<div class="wrap narrow" id="slider_images_edit">
		<?php
			if(isset($_GET['slider_images_edit']) || isset($_GET['slider_images_dup']))	{
				$id	=	$_GET['slider_images_edit'];
				if($id=='')
					$id = $_GET['slider_images_dup'];
					
				$query = "SELECT * FROM {$this->slider_images_table} WHERE id=$id ";
				$slider_image	=	$wpdb->get_row($query, ARRAY_A);
				
				if($_GET['slider_images_edit'])	{
					$header = __('Edit Slider Image for page/post: ', 'slider_images');
					$button_text = __('Submit &raquo;', 'slider_images');
					$nonce_name = "edit-slider_image_$id";
					$action_name = "slider_images-edit_slider_image";
				}
				$after = "<input type=\"hidden\" name=\"id\" value=\"{$slider_image['id']}\" />\n";
			}
			else	{
				$header = __('Add new slider image for posts/pages :', 'slider_images');
				$button_text = __('Submit &raquo;', 'slider_images');
				$nonce_name = "new-slider_image";
				$action_name = "slider_images-new_slider_image";
				$after = '';
			}

			$gallery=$wpdb->get_results("SELECT * FROM wp_image_gallery where gtype=1 order by gname");
		?>
		<script type="text/javascript">

			function Deleteimage(i,field) {
				if(confirm("Are you sure to delete your image")){
					document.sliderimages.removeimage.value=i;
					document.sliderimages.hdAction.value="remove"+field;
					document.sliderimages.submit();
				}
			}

			function validate_slider(frm,e,s){
				var msg="";
				if(frm.title.value=="")
				{
					msg="<p>Please enter title</p>";
					frm.title.focus();
				}
				else if(frm.pagepostpicture.value=="" && e=="")
				{
					msg="<p>Please select before image</p>";
					frm.pagepostpicture.focus();	
				}
				else if(frm.apagepostpicture.value=="" && e=="")
				{
					msg="<p>Please select after image</p>";
					frm.apagepostpicture.focus();	
				}
				else if(frm.gallery.value=="")
				{
					msg="<p>Please select gallery</p>";
					frm.gallery.focus();	
				}

				if(msg!="")
				{
					if(s>0)
					{
					document.getElementById('message').style.display="none";					
					}
					document.getElementById('err_msg').style.display="";
					document.getElementById('err_msg').innerHTML=msg;
					return false;
				}
				else
				{
					return true;
				}
			}
		</script>
			<?php if(isset($_GET['imgerr'])){?>
			<div class="error" id="err_msg">Slider image size should be 560px X 420px. Please try again.</div>
			<?php } ?>
			<h2><?php echo $header ?></h2>
			<p><?php echo $header_text ?></p>
			<form method="post" name="sliderimages" action="admin.php?page=slider_images_management" onsubmit="return validate_slider(this,'<?php echo $_GET['slider_images_edit']?>','<?php echo $_GET['slider_images_message']?>');" enctype="multipart/form-data">
			<input type="hidden" name="upcount" id="upcount" value="1">
			<input type="hidden" name="pdfcount" id="pdfcount" value="1">
			<input type="hidden" name="menuimgcount" id="menuimgcount" value="1">
			<input type="hidden" name="picturecount" id="picturecount" value="1">
			<input type="hidden" name="removeimage" id="removeimage" value="">
			<input type="hidden" name="hdAction" id="hdAction" value="">
			<table width="100%" cellspacing="2" cellpadding="5" class="editform form-table">
				<tbody>
					<tr>
						<th width="33%" valign="top" scope="row">
							<label for="title"><?php _e('Title', 'slider_images'); ?>:</label>
						</th>
						<td width="67%">
							<input type="text" size="50" value="<?php echo $slider_image['pimage_title']; ?>" id="title" name="title"/>	
						</td>
					</tr>
					<tr>
						<th width="33%" valign="top" scope="row" nowrap="nowrap">
							<label for="pagepostpicture"><?php _e('Before upload Image', 'slider_images'); ?>:</label>
						</th>
						<td width="67%">
							<input type="file" name="pagepostpicture" id="pagepostpicture"  size="27"/>
							560px X 420px (72 dpi)
							<?php if($slider_image['pimage_url'] !="")	{ ?>
							<img src="<?php echo get_settings('home'); ?>/wp-content/uploads/sliderimages/<?php echo $slider_image['pimage_url']; ?>" width="250" height="141" />
							<?php } ?>
						</td>
					</tr>
					
					<tr>
						<th width="33%" valign="top" scope="row" nowrap="nowrap">
							<label for="apagepostpicture"><?php _e('After upload Image', 'slider_images'); ?>:</label>
						</th>
						<td width="67%">
							<input type="file" name="apagepostpicture" id="apagepostpicture"  size="27"/>
							560px X 420px (72 dpi)
							<?php if($slider_image['pimage_url'] !="")	{ ?>
							<img src="<?php echo get_settings('home'); ?>/wp-content/uploads/sliderimages/<?php echo $slider_image['pimage_url']; ?>" width="250" height="141" />
							<?php } ?>							
						</td>
					</tr>
					
					<tr>
						<td colspan="2">
						
						</td>
					</tr>

					<tr>
						<th width="33%" valign="top" scope="row">
							<label for="description"><?php _e('Description', 'slider_images'); ?>:</label>
						</th>
						<td width="67%">
							<textarea rows="10" cols="50" name="description" id="description"><?php echo $slider_image['pimage_desc']; ?></textarea>
						</td>
					</tr>
						<th width="33%" valign="top" scope="row">
							<label for="description"><?php _e('Slide Show', 'slider_images'); ?>:</label>
						</th>
						<td width="67%">
							<select name="gallery">
							<?php foreach($gallery as $data){
							if($slider_image['gid']==$data->gid){
							?>
							<option selected="selected" value="<?php echo $data->gid;?>"><?php echo $data->gname;?></option>
							<?php }else{?>
							<option value="<?php echo $data->gid;?>"><?php echo $data->gname;?></option>
							<?php }} ?>
							</select>
						</td>
					</tr>
					<tr>
						<th width="33%" valign="top" scope="row">
							<label for="link"><?php _e('Image Alt Tag', 'slider_images'); ?>:</label>
						</th>
						<td width="67%">
							<input type="text" size="50" value="<?php echo $slider_image['pimage_link']; ?>" id="link" name="link"/>
						</td>
					</tr>
					<tr>
						<th width="33%" valign="top" scope="row">
							<label for="imgorder"><?php _e('Image Order', 'slider_images'); ?>:</label>
						</th>
						<td width="67%">
							<input type="text" size="10" value="<?php echo $slider_image['pimage_order']; ?>" id="imgorder" name="imgorder"/>
						</td>
					</tr>
				</tbody>
			</table>
			<p class="submit">
				<input type="submit" class="button-primary" value="<?php echo $button_text ?>" name="<?php echo $action_name ?>"/>
				
				<?php wp_nonce_field($nonce_name) ?>
				<?php echo $after ?>
			</form>
		</div>
<div class="wrap">
			<h2><?php _e("Slider images for the appropriate posts/pages", "slider_images"); ?></h2>
			<p></p>
			<table class="widefat">
				<thead>
					<tr>
						<th><?php _e('Id', 'slider_images'); ?></th>
						<th><?php _e('Title', 'slider_images'); ?></th>
						<th><?php _e('Before Image', 'slider_images'); ?></th>
						<th><?php _e('After Image', 'slider_images'); ?></th>
						<th><?php _e('Slider Name', 'slider_images'); ?></th>
						<th colspan="3"><?php _e('Actions', 'slider_images'); ?></th>
					</tr>
				</thead>
				<tbody>
				<?php if(empty($slider_images))	{ ?>
					<tr>
						<td colspan="7">
							<?php _e('You currently have no image for any pages/post. Add one below!', 'slider_images') ?>
						</td>
					</tr>
				<?php
					}
					else	{
						$class = "";
						$homesss = get_settings('home');
						foreach($slider_images as $hh)	{
							echo "<tr id=\"search-{$hh->id}\" class=\"$class\">";
							echo "<td>". $hh->id."</td>\n";
							echo "<td>". $hh->pimage_title."</td>\n";
							echo "<td><img src='".$homesss."/wp-content/uploads/sliderimages/".$hh->pimage_url."' width='110' height='75' /></td>\n";
							echo "<td><img src='".$homesss."/wp-content/uploads/sliderimages/".$hh->pimage_urlnew."' width='110' height='75' /></td>\n";
							echo "<td>". $hh->gname."</td>\n";
							echo "<td><a class='view' href='admin.php?page=slider_images_management&amp;slider_images_edit={$hh->id}#slider_images_edit'>Edit</a></td>\n";
							echo "<td><a class='delete' href='".wp_nonce_url("admin.php?page=slider_images_management&amp;slider_images-delete={$hh->id}&amp;slider_images_name={$hh->id}", 'delete-slider_images_'.$hh->id)."' onclick=\"return confirm('" . js_escape(sprintf( __("You are about to delete the slider image '%s'.\n'OK' to delete, 'Cancel' to stop.", 'slider_images'), $hh->id)) . "' );\">Delete</a></td>\n";
							echo "</tr>";
							$class = empty($class)?"alternate":"";
						}
					}
				?>
				</tbody>
			</table>
		</div>
		<?php
}

	function slider_images_pagepostid_sort($Mode='Display',$getPagePostids,$pagepost_id='')	{
		global $wpdb;
		if(empty($getPagePostids))	{
			$getPagePostid	=	"SELECT * FROM ".$wpdb->prefix."posts WHERE post_status='publish'";
			$getPagePostids	=	$wpdb->get_results($getPagePostid,ARRAY_A);
		}
		
		if($Mode!='Display')	{
			return $Location;
		}
		else	{
			foreach($getPagePostids as $PagePostid)	{
				$entry.='<option'.($pagepost_id == $PagePostid['ID'] ? ' SELECTED=SELECTED' : '').' value="'.$PagePostid['ID'].'"   name="'.$PagePostid['ID'].'">'.$PagePostid['ID'].'</option>';
			}
			return $entry;
		}
	}


	function object2array($object) {
		if (is_object($object)) {
			foreach ($object as $key => $value) {
				$array[$key] = $value;
			}
		}
		else {
			$array = $object;
		}
		return $array;
	}

	function object_to_array($object)	{
		if(is_array($object) || is_object($object))	{
			$array = array();
			foreach($object as $key => $value)	{
				$array[$key] = $this->object_to_array($value); 
			}
			return $array;
			
		}
		return $object;
	}

	function wp_get_sliderimages()	{
		global $wpdb;
		$getSlideImage_query	=	"SELECT * FROM {$this->slider_images_table} ORDER BY `pimage_order` ASC ";
		$getSlideImage		=	$wpdb->get_results($getSlideImage_query);
		return $getSlideImage;
	}

}
new SliderImages();
?>